
MemMenu:

	ld	a,0
	ld	e,21
	ld	b,6
	ld	c,22
	ld	hl,Menu+8
	call	OpenWindow

	ld	hl,Address
	ld	de,28*256+02
	ld	(pencol),de
	call	_vputs

	call	_Pause

DebugMem:

init:


mLoop:
	ld	de,38*256+14
	ld	(pencol),de
	ld	hl,(addressPTR)
	ld	a,h
	push	hl
	call	_dispHex
	pop	hl
	ld	a,l
	call	_dispHex
	call	_bufcopy
Choose:
	ld	a,$0ff
	out	(1),a
	ld	a,$0bf
	out	(1),a
	in	a,(1)
	cp	127
	jp	z,ReStart
	cp	223
	jp	z,ChooseViewers

	ld	a,$0ff
	out	(1),a
	ld	a,$0fe
	out	(1),a
	in	a,(1)
	cp	247
	jr	z,addup
	cp	254
	jr	z,adddown

	cp	250			;[RIGHT]+[DOWN]
	jr	z,addplus100
	cp	243			;[RIGHT]+[UP]
	jr	z,addminus100

	cp	252
	jr	z,addplusslowly
	cp	245
	jr	z,addminusslowly


	jp	Choose
addplusslowly:
	ld	hl,(addressPTR)
	inc	hl
	ld	(addressPTR),hl
	call	_Pause
	jr	mLoop
addminusslowly:
	ld	hl,(addressPTR)
	dec	hl
	ld	(addressPTR),hl
	call	_Pause
	jr	mLoop

adddown:
	ld	hl,(addressPTR)
	inc	hl
	ld	(addressPTR),hl
	jr	mLoop
addup:
	ld	hl,(addressPTR)
	dec	hl
	ld	(addressPTR),hl
	jr	mLoop
addplus100:
	ld	hl,(addressPTR)
	ld	de,100
	add	hl,de
	ld	(addressPTR),hl
	jp	mLoop	
addminus100:
	ld	hl,(addressPTR)
	ld	de,-100
	add	hl,de
	ld	(addressPTR),hl
	jp	mLoop

_Pause:
	ld	b,15
ploop:
	halt
	halt
	djnz	ploop
	ret

befHexViewer:
	call	_clrlcd
	call	_bufclr
HexViewer:

;	ld	a,(mode)
;	cp	1
;	jp	z,mainLoop
	ld	a,1
	ld	(mode),a

	ld	hl,(addressPTR)
	ld	(tempAdd),hl



	ld	b,16
	ld	c,1
	ld	d,16
	ld	e,63
	ld	h,1
	call	_iline

	ld	b,63
	ld	c,1
	ld	d,63
	ld	e,63
	ld	h,1
	call	_iline


	xor	a
	ld	(pencol),a
	ld	(penrow),a

	ld	b,9
hexviewloop:
	push	bc
	call	dispHexLine
	xor	a
	ld	(pencol),a
	ld	a,(penrow)
	add	a,7
	ld	(penrow),a
	pop	bc
	djnz	hexviewloop
	call	_bufcopy
	jp	mainLoop


dispHexLine:

dispAdd:
	ld	hl,(tempAdd)
	ld	a,h
	push	hl
	call	_dispHex
	pop	hl
	ld	a,l
	call	_dispHex

	ld	a,(pencol)
	add	a,2
	ld	(pencol),a
	ld	hl,(tempAdd)
	ld	b,5
dispHexcode:
	push	bc
	push	hl
	ld	a,(hl)
	call	_dispHex
	ld	a,' '
	call	_vputmap
	pop	hl
	inc	hl
	pop	bc
	djnz	dispHexcode


	ld	a,(pencol)
	add	a,2
	ld	(pencol),a
	ld	hl,(tempAdd)
	ld	b,5
dispASCIIcode:
	ld	a,(hl)
	call	_vputmap
	ld	a,' '
	call	_vputmap
	inc	hl
	djnz	dispASCIIcode

	ld	(tempAdd),hl

	ret


zhxDown:
	ld	hl,(addressPTR)
	ld	de,5
	add	hl,de
	ld	(addressPTR),hl
	ld	(tempAdd),hl
	jp	HexViewer
zhxUp:
	ld	hl,(addressPTR)
	ld	de,-5
	add	hl,de
	ld	(addressPTR),hl
	ld	(tempAdd),hl
	jp	HexViewer




Address:		.db	"address:",0


.end

